----------------------------------------------------------------------
-- WKMascot State/_EH[N 
----------------------------------------------------------------------

local math               = math;
local setmetatable       = setmetatable;
local MOD				 = MOD;
local cpp_GetWorldSize   = cpp_GetWorldSize;

module("MOD.AI.State.RandomWalk");

State_RandomWalk = {};

-------------------------------------------------
--
-------------------------------------------------

function new()

	self = {
		m_MoveToX = 0;
		m_MoveToZ = 0;
	}

	return setmetatable(self,{__index=State_RandomWalk});

end


--====================================================================
--Xe[g
--====================================================================

-------------------------------------------------
--Jn
-------------------------------------------------

function State_RandomWalk:Start( mascot )

	local wx, wy, wz = cpp_GetWorldSize();

	local dx = wx - 2000; --(1mƂ)̃TCY 
	local dz = wz - 2000; --(1mƂ)̃TCY

	self.m_MoveToX = math.random() * dx - dx / 2;
	self.m_MoveToZ = math.random() * dz - dz / 2;

	mascot:SetMotion( "walk" );

end

-------------------------------------------------
--I
-------------------------------------------------

function State_RandomWalk:End( mascot )

end

-------------------------------------------------
--[v
-------------------------------------------------

function State_RandomWalk:Loop( mascot )

	--ݒ
	local posx, posy, posz = mascot:GetPos();
	local dx = self.m_MoveToX - posx;
	local dz = self.m_MoveToZ - posz;

	if dx * dx + dz * dz < 200 * 200 then

		mascot:ChangeState( MOD.AI.State.WaitIdle.new() );

	else

		local dir = math.atan2( dx, dz );
		mascot:SetDir( dir, 200 );

	end

end


